package landingpage;


import org.vaadin.csvalidation.CSValidator;

import com.vaadin.annotations.Theme;
import com.vaadin.annotations.VaadinServletConfiguration;
import com.vaadin.server.VaadinRequest;
import com.vaadin.server.VaadinServlet;
import com.vaadin.ui.TextArea;
import com.vaadin.ui.UI;
import com.vaadin.ui.VerticalLayout;

@SuppressWarnings("serial")
@Theme("landingpage")
public class LandingpageUI extends UI {


	@VaadinServletConfiguration(productionMode = false, ui = LandingpageUI.class, 
		widgetset = "landingpage.widgetset.LandingpageWidgetset", 
		heartbeatInterval=300,
		closeIdleSessions = true)

	public static class Servlet extends VaadinServlet {
	}
	
	@Override
	protected void init(VaadinRequest request) {
		final VerticalLayout layout = new VerticalLayout();
		layout.setMargin(true);
		setContent(layout);		
		final TextArea limited = new TextArea("Length Limit");
		limited.setColumns(30);
		limited.setRows(5);

		CSValidator validator = new CSValidator();
		validator.extend(limited);
		validator.setJavaScript("var maxvalue = 20;\n" +
		                      "var charsleft = maxvalue - value.length;\n" +
		                      "var result = null;\n" +
		                      "if (charsleft > 0)\n" +
		                      "    result = \"valid \" + value.length + \" of \" + maxvalue;\n" +
		                      "else\n" +
		                      "    result = \"\" + value.length + \" of \" + maxvalue;\n" +
		                      "result;");
		validator.setValidateEmpty(true);
		layout.addComponent(limited);
	}

}